/* gtk-first.c
 *
 *       GTK+.
 *     "Say",        
 *  .
 *
 * :   <akolosov@cs.karelia.ru>
 * Last change: Time-stamp: <02--2008 15:28:48 akolosov>
*/

#include <gtk/gtk.h>

#define ENTRY_MAX_LEN 50

typedef struct _AppInputData {
    GtkWidget* text_entry;
    GtkWidget* filename_entry;
} AppInputData;

/* -    . */
void cb_button_click( GtkWidget *widget, gpointer data ) 
{
    /*        AppInputData */
    AppInputData* appData = (AppInputData*) data;

    /*        . */
    GtkEntry* entry = GTK_ENTRY(appData->text_entry);

    /*     . */
    const gchar* text = gtk_entry_get_text(entry);
    
    /*  . */
    g_print ("%s\n", text);
}

/* -   . */
void cb_destroy( GtkWidget *widget, gpointer data )
{
    gtk_main_quit ();
}

int main( int argc, char *argv[] )
{
    /*    */
    GtkWidget* window;
    GtkWidget* vbox;
    GtkWidget* button;
	
    /*     */
    AppInputData inputData;
    
    /*       GTK-.
     *     
     *   . */
    gtk_init(&argc, &argv);
    
    /*    */
    window = gtk_window_new(GTK_WINDOW_TOPLEVEL);

    /*   "destroy"   .
     *   ,    gtk_widget_destroy()
     *      "delete_event"  FALSE. */
    g_signal_connect(G_OBJECT (window), "destroy",
		     G_CALLBACK(cb_destroy), NULL);
    
    /*    . */
    gtk_container_set_border_width(GTK_CONTAINER(window), 10);
    
    /*      "Say". */
    button = gtk_button_new_with_label("Say");
    
    /*     "clicked",  
     * cb_button_click(),      
     *   ,   . */
    g_signal_connect(G_OBJECT(button), "clicked",
                     G_CALLBACK(cb_button_click), &inputData);
		     

    /*        . */
    inputData.text_entry = gtk_entry_new_with_max_length(ENTRY_MAX_LEN);

    /*     . */
    vbox = gtk_vbox_new(FALSE, 1);

    /*    . */
    gtk_container_add(GTK_CONTAINER(vbox), inputData.text_entry);
    gtk_container_add(GTK_CONTAINER(vbox), button);
    
    /*     (   ). */
    gtk_container_add(GTK_CONTAINER(window), vbox);
    
    /*       . */
    gtk_widget_show_all(window);
    
    /*  GTK-    gtk_main().
     *      
     * (     ). */
    gtk_main();
    
    return 0;
}
